import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.GridLayout;

public class MultiBallWorldFrame extends Frame
{
    private static final int FrameWidth  = 600;
    private static final int FrameHeight = 400;

    public MultiBallWorldFrame( Color ballColor )
    {
        super();

        setSize ( FrameWidth, FrameHeight*2  );
        setTitle( "Two Ball Worlds in a Grid" );

        setLayout( new GridLayout(2, 1) );

        add( new MultiBallWorldPanel( ballColor ) );
        add( new MultiBallWorldPanel( ballColor ) );
    }

    public void paint( Graphics g )
    {
        // nothing needed
    }
}
