import java.awt.Color;
import java.awt.Panel;
import java.awt.Graphics;
import java.awt.GridLayout;
import java.awt.Label;

public class MultiBallWorldGrid extends Panel
{
    private static final int FrameWidth  = 600;
    private static final int FrameHeight = 400;

    public MultiBallWorldGrid( Color ballColor )
    {
        super();

        setSize  ( FrameWidth, FrameHeight );
        setLayout( new GridLayout(2, 2) );

        for (int i = 0; i < 4; i++)
            add( new MultiBallWorldPanel( ballColor ) );
    }

    public void paint( Graphics g )
    {
        // nothing needed
    }
}
